## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 14;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# OCaml packages not built on i686 since OCaml 5 / Fedora 39.
ExcludeArch: %{ix86}

# Fedora does not have crowbar, ezjsonm, or junit_alcotest
%global run_tests 0

%global giturl  https://github.com/avsm/ocaml-yaml

Name:           ocaml-yaml
Version:        3.2.0
Release:        %autorelease
Summary:        Parse and generate YAML 1.1/1.2 files

License:        ISC
URL:            https://avsm.github.io/ocaml-yaml/
VCS:            git:%{giturl}.git
Source:         %{giturl}/releases/download/v%{version}/yaml-%{version}.tbz

# Unbundle libyaml.  See:
# - https://github.com/yaml/libyaml/pull/235
# - https://github.com/avsm/ocaml-yaml/issues/51
Patch:          %{name}-unbundle-libyaml.patch

BuildRequires:  libyaml-devel
BuildRequires:  ocaml >= 4.13.0
BuildRequires:  ocaml-bos-devel
BuildRequires:  ocaml-ctypes-devel >= 0.14.0
BuildRequires:  ocaml-dune >= 2.0
BuildRequires:  ocaml-dune-configurator-devel
BuildRequires:  ocaml-ppx-sexp-conv-devel >= 0.9.0
BuildRequires:  ocaml-sexplib-devel

# Test dependencies
%if %{run_tests}
BuildRequires:  ocaml-alcotest-devel >= 1.5.0
BuildRequires:  ocaml-crowbar-devel
BuildRequires:  ocaml-ezjsonm-devel
BuildRequires:  ocaml-fmt-devel
BuildRequires:  ocaml-junit-alcotest-devel
BuildRequires:  ocaml-logs-devel
BuildRequires:  ocaml-mdx-devel >= 2.1.0
%endif

%description
This is an OCaml library to parse and generate the YAML file format.  It
is intended to be interoperable with the Ezjsonm
(https://github.com/mirage/ezjsonm) JSON handling library, if the simple
common subset of Yaml is used.  Anchors and other advanced Yaml features
are not implemented in the JSON compatibility layer.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       libyaml-devel%{?_isa}
Requires:       ocaml-bos-devel%{?_isa}
Requires:       ocaml-ctypes-devel%{?_isa}

%description    devel
The %{name}-devel package contains libraries and signature
files for developing applications that use %{name}.

%package        sexp
Summary:        Parse and generate YAML 1.1/1.2 files with sexp support
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    sexp
This package adds sexp support to the functionality of ocaml-yaml.

%package        sexp-devel
Summary:        Development files for %{name}-sexp
Requires:       %{name}-devel%{?_isa} = %{version}-%{release}
Requires:       %{name}-sexp%{?_isa} = %{version}-%{release}
Requires:       ocaml-ppx-sexp-conv-devel%{?_isa}
Requires:       ocaml-sexplib-devel%{?_isa}

%description    sexp-devel
The %{name}-sexp-devel package contains libraries and signature
files for developing applications that use %{name}-sexp.

%prep
%autosetup -N -n yaml-%{version}

# Unbundle the included copy of libyaml.
# https://bugzilla.redhat.com/show_bug.cgi?id=2217729#c4
rm vendor/{*.c,yaml.h,yaml_private.h}
cp -p %{_includedir}/yaml.h vendor/yaml.h
%patch -P0 -p1
touch vendor/dummy.c
ln -s %{_libdir}/libyaml.so ffi/lib/dllyaml.so

%build
%dune_build

%install
%dune_install -s

%if %{run_tests}
%check
%dune_check
%endif

%files -f .ofiles-yaml
%license LICENSE.md
%doc README.md CHANGES.md

%files devel -f .ofiles-yaml-devel

%files sexp -f .ofiles-yaml-sexp
%license LICENSE.md
%doc README.md CHANGES.md

%files sexp-devel -f .ofiles-yaml-sexp-devel

%changelog
## START: Generated by rpmautospec
* Fri Jan 10 2025 Jerry James <loganjerry@gmail.com> - 3.2.0-14
- OCaml 5.3.0 rebuild for Fedora 42

* Tue Oct 08 2024 Richard W.M. Jones <rjones@redhat.com> - 3.2.0-13
- Rebuild for ocaml-lwt 5.8.0

* Tue Aug 13 2024 Jerry James <loganjerry@gmail.com> - 3.2.0-12
- Rebuild for ocaml-ctypes 0.23.0

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Wed Jul 17 2024 Jerry James <loganjerry@gmail.com> - 3.2.0-10
- Minor spec file simplification

* Wed Jul 03 2024 Jerry James <loganjerry@gmail.com> - 3.2.0-9
- Rebuild for ocaml-sexplib 0.17.0

* Wed Jun 19 2024 Richard W.M. Jones <rjones@redhat.com> - 3.2.0-8
- OCaml 5.2.0 ppc64le fix

* Wed May 29 2024 Richard W.M. Jones <rjones@redhat.com> - 3.2.0-7
- OCaml 5.2.0 for Fedora 41

* Thu May 23 2024 Jerry James <loganjerry@gmail.com> - 3.2.0-6
- Add VCS field

* Thu Jan 25 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Dec 18 2023 Richard W.M. Jones <rjones@redhat.com> - 3.2.0-3
- OCaml 5.1.1 + s390x code gen fix for Fedora 40

* Tue Dec 12 2023 Richard W.M. Jones <rjones@redhat.com> - 3.2.0-2
- OCaml 5.1.1 rebuild for Fedora 40

* Tue Nov 14 2023 Jerry James <loganjerry@gmail.com> - 3.2.0-1
- Version 3.2.0

* Thu Oct 05 2023 Richard W.M. Jones <rjones@redhat.com> - 3.1.0-6
- OCaml 5.1 rebuild for Fedora 40

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 3.1.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Fri Jul 14 2023 Jerry James <loganjerry@gmail.com> - 3.1.0-4
- Rebuild for ocaml-ctypes 0.21.0

* Wed Jul 12 2023 Richard W.M. Jones <rjones@redhat.com> - 3.1.0-3
- OCaml 5.0 rebuild for Fedora 39

* Tue Jul 11 2023 Richard W.M. Jones <rjones@redhat.com> - 3.1.0-2
- ExcludeArch i686 (https://lists.fedoraproject.org/archives/list/devel@lis
  ts.fedoraproject.org/message/SPML7CUBSZNI36NLXGVHEG7DNHU3EWOJ/)

* Fri Jun 30 2023 Jerry James <loganjerry@gmail.com> - 3.1.0-1
- Initial import
## END: Generated by rpmautospec
